=== debian/changelog ===
xrootd-s3-http (0.1.8-2) unstable; urgency=medium

  * Add missing BuildDepends pkgconf
  * Link with libatomic if needed

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 13 Jan 2025 23:38:07 +0100

xrootd-s3-http (0.1.8-1) unstable; urgency=medium

  * Update to version 0.1.8
  * Drop patches accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 31 Dec 2024 11:00:00 +0100

xrootd-s3-http (0.1.7-1) unstable; urgency=medium

  * Initial release. (Closes: #1086001)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 24 Oct 2024 14:57:22 +0200
