=== debian/changelog ===
xrootd-s3-http (0.2.1-4) unstable; urgency=medium

  * Use the hostname localhost for http tests

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 03 Feb 2025 18:46:28 +0100

xrootd-s3-http (0.2.1-3) unstable; urgency=medium

  * Increase the timeout when waiting for the xrootd server to start
    during testing

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 02 Feb 2025 23:11:07 +0100

xrootd-s3-http (0.2.1-2) unstable; urgency=medium

  * Add missing BuildDepends procps (for tests)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 02 Feb 2025 18:01:27 +0100

xrootd-s3-http (0.2.1-1) unstable; urgency=medium

  * Update to version 0.2.1
  * Drop libatomic patch - issue fixed upstream
  * Run http unit tests

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 02 Feb 2025 11:33:14 +0100
