=== debian/control ===
--- 
+++ 
@@ -9,7 +9,12 @@
  libxrootd-server-dev,
  libcurl4-openssl-dev,
  libssl-dev,
- libtinyxml2-dev
+ libtinyxml2-dev,
+ libgtest-dev,
+ curl,
+ openssl,
+ procps,
+ xrootd-server
 Homepage: https://github.com/PelicanPlatform/xrootd-s3-http
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
 Vcs-Browser: https://salsa.debian.org/ellert/xrootd-s3-http
