=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,13 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DXROOTD_EXTERNAL_TINYXML2:BOOL=ON \
+		-DXROOTD_PLUGINS_EXTERNAL_GTEST:BOOL=ON \
+		-DBUILD_TESTING:BOOL=ON \
 		-DLIB_INSTALL_DIR:PATH=/usr/lib/$(DEB_HOST_MULTIARCH)
+
+override_dh_auto_test:
+	# Run only http tests. S3 tests require network and S3 client binaries.
+	dh_auto_test -- ARGS+="-R 'http|HTTP'"
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
