=== debian/changelog ===
xrootd-s3-http (0.4.1-2) unstable; urgency=medium

  * Fix broken glob filter

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 08 Jun 2025 12:03:16 +0200

xrootd-s3-http (0.4.1-1) unstable; urgency=medium

  * Update to version 0.4.1
  * Drop patches - accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 07 Jun 2025 13:34:25 +0200
