=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: xrootd-s3-http
 Section: net
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
