=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,12 @@
 		-DXROOTD_EXTERNAL_TINYXML2:BOOL=ON \
 		-DXROOTD_PLUGINS_EXTERNAL_GTEST:BOOL=ON \
 		-DBUILD_TESTING:BOOL=ON \
-		-DLIB_INSTALL_DIR:PATH=/usr/lib/$(DEB_HOST_MULTIARCH)
+		-DEXE_BIN:PATH=/bin/true \
+		-DGoWrk:PATH=/bin/true
 
 override_dh_auto_test:
 	# Run only http tests. S3 tests require network and S3 client binaries.
-	dh_auto_test -- ARGS+="-R 'http|HTTP'"
+	dh_auto_test -- ARGS+="-R 'http|HTTP|FileSystemGlob'"
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
