=== debian/changelog ===
xrootd-s3-http (0.5.0-2) unstable; urgency=medium

  * Portablity and test fixes

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 25 Aug 2025 22:23:51 +0200

xrootd-s3-http (0.5.0-1) unstable; urgency=medium

  * Update to version 0.5.0
  * Drop patch - accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 25 Aug 2025 10:43:46 +0200
