=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DXROOTD_EXTERNAL_TINYXML2:BOOL=ON \
		-DXROOTD_PLUGINS_EXTERNAL_GTEST:BOOL=ON \
		-DENABLE_TESTS:BOOL=ON

override_dh_auto_test:
	# s3 tests require network (https://s3.us-east-1.amazonaws.com)
	# posc tests fail when run in parallel:
	# https://github.com/PelicanPlatform/xrootd-s3-http/issues/111
	dh_auto_test -- ARGS+="-E 'S3|s3|TestPosc'"

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
