## xrootd-s3-http 0.5.1

=== debian/changelog ===
xrootd-s3-http (0.5.1-1) unstable; urgency=medium

  * Update to version 0.5.1
  * Drop patches - accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 02 Sep 2025 10:59:38 +0200

xrootd-s3-http (0.5.0-3) unstable; urgency=medium

  * Check file access flags correctly

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 26 Aug 2025 17:51:02 +0200
